//+------------------------------------------------------------------+
//|                                               Advanced forecater |
//+------------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1 DarkGray
#property indicator_color4 LimeGreen
#property indicator_color5 LimeGreen
#property indicator_color2 Orange
#property indicator_color3 Orange
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_width4 2
#property indicator_width5 2

//
//
//
//
//

extern string TimeFrame    = "Current time frame";
extern int    FastEma      = 13;
extern int    SlowEma      = 34;
extern int    SignalMA     = 8;
extern int    SignalMAMode = MODE_EMA;

double temp1[];
double temp2[];
double sum[];
double sumua[];
double sumub[];
double sumda[];
double sumdb[];
double state[];

string indicatorFileName;
bool   returnBars;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------

int init() 
{
   IndicatorBuffers(8);   
   SetIndexBuffer(0,sum);
   SetIndexBuffer(1,sumua);
   SetIndexBuffer(2,sumub);
   SetIndexBuffer(3,sumda);
   SetIndexBuffer(4,sumdb);
   SetIndexBuffer(5,temp1);
   SetIndexBuffer(6,temp2);
   SetIndexBuffer(7,state);
      timeFrame         = stringToTimeFrame(TimeFrame);
      indicatorFileName = WindowExpertName();
      returnBars        = (TimeFrame=="returnBars"); if (returnBars) return(0);
   IndicatorShortName(timeFrameToString(timeFrame)+" Advanced_forecater");
   return (0);
}

//
//
//
//
//

int start() 
{
   int countedBars = IndicatorCounted();
      if(countedBars<0) return(-1);
      if(countedBars>0) countedBars--;
         int i,limit = MathMin(Bars-countedBars,Bars-1);
         if (returnBars) { sum[0] = limit+1; return(0); }
            double Multiply_Factor_1 = 2.0 / (FastEma + 1.0);
            double Multiply_Factor_2 = 2.0 / (SlowEma + 1.0);
            double Multiply_Factor_3 = Multiply_Factor_1 - Multiply_Factor_2;
                  if (MathAbs(Multiply_Factor_3) == 0.0) return(0);
                  if (timeFrame!=Period())
                  {
                     limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
                     if (state[limit]== 1) CleanPoint(limit,sumua,sumub);
                     if (state[limit]==-1) CleanPoint(limit,sumda,sumdb);
                        for(i=limit; i>=0; i--)
                        {
                           int y = iBarShift(NULL,timeFrame,Time[i]);
                           sum[i]   = iCustom(NULL,timeFrame,indicatorFileName,"",FastEma,SlowEma,SignalMA,SignalMAMode,0,y);
                           state[i] = iCustom(NULL,timeFrame,indicatorFileName,"",FastEma,SlowEma,SignalMA,SignalMAMode,7,y);
                           sumua[i] = EMPTY_VALUE;
                           sumub[i] = EMPTY_VALUE;
                           sumda[i] = EMPTY_VALUE;
                           sumdb[i] = EMPTY_VALUE;
                              if (state[i]== 1) PlotPoint(i,sumua,sumub,sum);
                              if (state[i]==-1) PlotPoint(i,sumda,sumdb,sum);
                        }                           
                        return(0);
                  }

   //
   //
   //
   //
   //
 
   if (state[limit]== 1) CleanPoint(limit,sumua,sumub);
   if (state[limit]==-1) CleanPoint(limit,sumda,sumdb);
   for(i=limit; i>=0; i--) temp1[i] = iMA(NULL,0,FastEma,0,MODE_EMA, PRICE_CLOSE,i)-iMA(NULL,0,SlowEma,0,MODE_EMA,PRICE_CLOSE,i);
   for(i=limit; i>=0; i--) temp2[i] = iMAOnArray(temp1,0,SignalMA,0,SignalMAMode,i);
   for(i=limit; i>=0; i--)
   {
      sumua[i] = EMPTY_VALUE;
      sumub[i] = EMPTY_VALUE;
      sumda[i] = EMPTY_VALUE;
      sumdb[i] = EMPTY_VALUE;
      sum[i] = (Multiply_Factor_1 * iMA(NULL,0,FastEma,0,MODE_EMA,PRICE_CLOSE,i)+                  iMA(NULL,0,SlowEma,0,MODE_EMA,PRICE_CLOSE,i) - 
                                    iMA(NULL,0,FastEma,0,MODE_EMA,PRICE_CLOSE,i)-Multiply_Factor_2*iMA(NULL,0,SlowEma,0,MODE_EMA,PRICE_CLOSE,i) + temp2[i]) / Multiply_Factor_3;
      state[i] = 0;
      if (sum[i]>High[i]) state[i] =  1;
      if (sum[i]<Low[i])  state[i] = -1;
      if (state[i]== 1) PlotPoint(i,sumua,sumub,sum);
      if (state[i]==-1) PlotPoint(i,sumda,sumdb,sum);
   }
   return (0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs) {
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf) {
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str) {
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--) {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}